//+------------------------------------------------------------------+
//|                                                 GannSessions.mq4 |
//|                                  Copyright  2012, Serg&&Santado |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Serg&&Santado"
#property link      "santado@rambler.ru"

#property indicator_chart_window

//-------    -------------------------------
extern int    NumberOfDays = 4;         //  
extern string AsiaBegin    = "03:00";   //   
extern string AsiaEnd      = "09:00";   //   
extern color  AsiaColor    = Goldenrod; //   
extern string EurBegin     = "10:00";   //   
extern string EurEnd       = "18:30";   //   
extern color  EurColor     = Tan;       //   
extern string USABegin     = "16:30";   //   
extern string USAEnd       = "23:00";   //   
extern color  USAColor     = SlateGray; //   


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  DeleteObjects();
  for (int i=0; i<NumberOfDays; i++) {
    CreateObjects("AS"+i, AsiaColor);
    CreateObjects("EU"+i, EurColor);
    CreateObjects("US"+i, USAColor);
  }
  Comment("");
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  DeleteObjects();
  Comment("");
}

//+------------------------------------------------------------------+
//|                                        |
//| :                                                       |
//|   no -                                        |
//|   cl -                                                |
//+------------------------------------------------------------------+
void CreateObjects(string no, color cl) {
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, True);
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DeleteObjects() {
  ObjectsDeleteAll(0,OBJ_TREND);
  ObjectsDeleteAll(0,OBJ_FIBOARC);
  ObjectsDeleteAll(0,OBJ_GANNGRID);
  for (int i=0; i<NumberOfDays; i++) {
    ObjectDelete("AS"+i);
    ObjectDelete("EU"+i);
    ObjectDelete("US"+i);
  }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  datetime dt=CurTime();

  for (int i=0; i<NumberOfDays; i++) {
    DrawObjects(dt, "AS"+i, AsiaBegin, AsiaEnd);
    DrawObjects(dt, "EU"+i, EurBegin, EurEnd);
    DrawObjects(dt, "US"+i, USABegin, USAEnd);
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
    datetime tl1=ObjectGet("AS"+i,OBJPROP_TIME2);
    datetime tl2=tl1+24*3600;
    double pl1=ObjectGet("AS"+i,OBJPROP_PRICE1);
    double pl2=ObjectGet("AS"+i,OBJPROP_PRICE2);
    double pivot=pl2;
    DrawTrend("Pivot"+i,tl1,tl2,pivot,BlueViolet,2);
    if (Digits <= 3) double q = 0.1;
    else q = 0.01;
    double range=MathPow(MathSqrt(pivot)+q,2)-pivot-pl1+pl2;
    DrawTrend("Up1"+i,tl1,tl2,pivot+range*0.125,Blue,1);
    DrawTrend("Up2"+i,tl1,tl2,pivot+range*0.25,Blue,1);
    DrawTrend("Up3"+i,tl1,tl2,pivot+range*0.333,Blue,2);
    DrawTrend("Up4"+i,tl1,tl2,pivot+range*0.375,Blue,1);
    DrawTrend("Up5"+i,tl1,tl2,pivot+range*0.5,Blue,2);
    DrawTrend("Up6"+i,tl1,tl2,pivot+range*0.625,Blue,1);
    DrawTrend("Up7"+i,tl1,tl2,pivot+range*0.666,Blue,2);
    DrawTrend("Up8"+i,tl1,tl2,pivot+range*0.750,Blue,1);
    DrawTrend("Up9"+i,tl1,tl2,pivot+range*0.875,Blue,1);
    DrawTrend("Up10"+i,tl1,tl2,pivot+range*1,Blue,2);
    DrawTrend("Dn1"+i,tl1,tl2,pivot-range*0.125,Red,1);
    DrawTrend("Dn2"+i,tl1,tl2,pivot-range*0.25,Red,1);
    DrawTrend("Dn3"+i,tl1,tl2,pivot-range*0.333,Red,2);
    DrawTrend("Dn4"+i,tl1,tl2,pivot-range*0.375,Red,1);
    DrawTrend("Dn5"+i,tl1,tl2,pivot-range*0.5,Red,2);
    DrawTrend("Dn6"+i,tl1,tl2,pivot-range*0.625,Red,1);
    DrawTrend("Dn7"+i,tl1,tl2,pivot-range*0.666,Red,2);
    DrawTrend("Dn8"+i,tl1,tl2,pivot-range*0.750,Red,1);
    DrawTrend("Dn9"+i,tl1,tl2,pivot-range*0.875,Red,1);
    DrawTrend("Dn10"+i,tl1,tl2,pivot-range*1,Red,2);
    
    if (i==0) {
      datetime tg1=ObjectGet("EU"+i,OBJPROP_TIME1);
      datetime tg2=ObjectGet("US"+i,OBJPROP_TIME1);
      ObjectDelete("GG");
      ObjectCreate("GG",OBJ_GANNGRID,0,tg1,pivot-range*0.666-range/18,tg1+(tg2-tg1)/2,pivot-range*0.666);  
      ObjectSet("GG",OBJPROP_STYLE, STYLE_SOLID); 
      ObjectSet("GG",OBJPROP_SCALE, 1);
      ObjectSet("GG",OBJPROP_COLOR, DarkSlateGray);
      ObjectSet("GG",OBJPROP_BACK,False);
      
      int T=13*60/Period();
      int scale=range/Point/T/2;
      ObjectDelete("Arc");
      ObjectCreate("Arc",OBJ_FIBOARC,0,tg1,pivot+range,tg1,pivot);
      ObjectSet("Arc",OBJPROP_FIBOLEVELS,10);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+0,0.125);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+1,0.25);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+2,0.333);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+3,0.375);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+4,0.5);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+5,0.625);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+6,0.666);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+7,0.75);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+8,0.875);
      ObjectSet("Arc",OBJPROP_FIRSTLEVEL+9,1);
      ObjectSet("Arc",OBJPROP_SCALE,scale);
      ObjectSet("Arc",OBJPROP_LEVELCOLOR,DodgerBlue);
      ObjectSet("Arc",OBJPROP_COLOR,CLR_NONE);
      ObjectSet("Arc",OBJPROP_ELLIPSE,true);
      ObjectSet("Arc",OBJPROP_BACK,false);
    }
  }
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DrawTrend(string name, datetime ot, datetime ct, double level, color cl, int width) {
    ObjectDelete(name);
    if (ObjectCreate(name, OBJ_TREND, 0, ot, level, ct, level)) {
    ObjectSet(name, OBJPROP_COLOR, cl);
    ObjectSet(name, OBJPROP_WIDTH, width);
    ObjectSet(name, OBJPROP_BACK, false);
    ObjectSet(name, OBJPROP_RAY, false);
    }
}

//+------------------------------------------------------------------+
//|                                       |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te) {
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1)+1;
  b2=iBarShift(NULL, 0, t2)+1;
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
}

//+------------------------------------------------------------------+
//|                                  |
//| :                                                       |
//|   dt -                                           |
//+------------------------------------------------------------------+
datetime decDateTradeDay (datetime dt) {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+

